package cn.iocoder.yudao.module.system.controller.admin.home;

import cn.iocoder.yudao.framework.common.pojo.CommonResult;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.tenant.core.aop.TenantIgnore;
import cn.iocoder.yudao.framework.tenant.core.context.TenantContextHolder;
import cn.iocoder.yudao.module.system.controller.admin.home.vo.HomeServiceAreaPageReqVO;
import cn.iocoder.yudao.module.system.controller.admin.home.vo.HomeServiceAreaRespVO;
import cn.iocoder.yudao.module.system.controller.admin.home.vo.HomeServiceAreaSaveReqVO;
import cn.iocoder.yudao.module.system.service.home.HomeServiceAreaService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.validation.Valid;

import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;

@Tag(name = "管理后台 - 居家服务区域")
@RestController
@RequestMapping("/home/service-area")
@Validated
public class HomeServiceAreaController {

    @Resource
    private HomeServiceAreaService homeServiceAreaService;

    @PostMapping("/create")
    @Operation(summary = "新增居家服务区域")
    @TenantIgnore
    public CommonResult<Long> create(@Valid @RequestBody HomeServiceAreaSaveReqVO createReqVO) {
        if (createReqVO.getTenantId() == null) {
            createReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        return success(homeServiceAreaService.createHomeServiceArea(createReqVO));
    }

    @PutMapping("/update")
    @Operation(summary = "修改居家服务区域")
    @TenantIgnore
    public CommonResult<Boolean> update(@Valid @RequestBody HomeServiceAreaSaveReqVO updateReqVO) {
        if (updateReqVO.getTenantId() == null) {
            updateReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        homeServiceAreaService.updateHomeServiceArea(updateReqVO);
        return success(true);
    }

    @DeleteMapping("/delete")
    @Operation(summary = "删除居家服务区域")
    @Parameter(name = "id", description = "编号", required = true, example = "1")
    @TenantIgnore
    public CommonResult<Boolean> delete(@RequestParam("id") Long id) {
        homeServiceAreaService.deleteHomeServiceArea(id);
        return success(true);
    }

    @GetMapping("/get")
    @Operation(summary = "获得居家服务区域详情")
    @Parameter(name = "id", description = "编号", required = true, example = "1")
    @TenantIgnore
    public CommonResult<HomeServiceAreaRespVO> get(@RequestParam("id") Long id) {
        return success(homeServiceAreaService.getHomeServiceArea(id));
    }

    @GetMapping("/page")
    @Operation(summary = "获得居家服务区域分页")
    @TenantIgnore
    public CommonResult<PageResult<HomeServiceAreaRespVO>> getPage(@Valid HomeServiceAreaPageReqVO pageReqVO) {
        if (pageReqVO.getTenantId() == null) {
            pageReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        return success(homeServiceAreaService.getHomeServiceAreaPage(pageReqVO));
    }
}

